/*
    Quickly whipped up lexer in order to locate shellcode in source files
    Too slow and unreliable at this time

    -- Scrippie
*/

#include <stdio.h>
#include <locale.h>
#include "lexer.h"
#include "keywords.h"

int lineno=1;

void lexInit(void)
{
      setlocale(LC_ALL, "POSIX");
      /* Where did that good old ISO-8859-1 locale go... :( */
}

void lexAnalyze(void)
{
   int ic, i=0;

   token.val[0] = 0;

   while(isblank((ic=fgetc(input))));		/* Skip blanks (GNU only) */

   if(ic == EOF) {
      token.id=0;
      strcpy(token.val, "EOF");
      return;
   }

   if(isdigit(ic)) {
      token.val[i++] = (char) ic;
      while((ic = fgetc(input)) != EOF && isdigit(ic) && i < MAXTOKLEN) {
         token.val[i++] = (char) ic;
      }
      token.val[i] = 0;
      token.id = NUMBER;
      ungetc(ic, input);
      return;
   }

   if(isident(ic)) {
      token.val[i++] = (char) ic;
      while((ic = fgetc(input)) != EOF && isident(ic) && i < MAXTOKLEN) {
         token.val[i++] = (char) ic;
      }
      token.val[i] = 0;
      ungetc(ic, input);

      if((token.id = isKeyword(token.val)) == 0) token.id = IDID;
      return;
   }

   switch(ic) {

      case '/':
         if((ic = fgetc(input)) == '/') {
            token.id = COMMENT;
            while((ic = fgetc(input)) != EOF && ic != '\n');
            if(ic == '\n') lineno++;
         }
         else if(ic == '*') {
            strcpy(token.val, "/* */");
            token.id = COMMENT;
            do {
               while((ic = fgetc(input)) != EOF && ic != '*');
            } while((ic = fgetc(input)) != '/' && ic != EOF);
         }
         else {
            ungetc(ic, input);
            strcpy(token.val, "/");
            token.id = OPERATOR;
         }
         break;

      case '"':
         while((ic = fgetc(input)) != '"' && ic != EOF && i < MAXTOKLEN) {
            token.val[i++] = (char) ic;
         }
         while(isspace((ic=fgetc(input))));

         do {
            if(ic == '"') {
               while((ic = fgetc(input)) != '"' && ic != EOF && i < MAXTOKLEN) {
                  token.val[i++] = (char) ic;
               }
               while(isspace((ic=fgetc(input))));
            }
         } while (ic == '"' && ic != EOF);

         token.val[i] = 0;
         token.id = STRINGID;
         break;

      case '=':
         if((ic=fgetc(input)) == '=') {
            strcpy(token.val, "==");
            token.id = COMPEQUALSIGN;
         }
         else {
            ungetc(ic, input);
            strcpy(token.val, "=");
            token.id = EQUALSID;
         }
         break;

      case '|':
         if((ic=fgetc(input)) == '|') {
            strcpy(token.val, "||");
            token.id = COMPOR;
         }
         else {
            ungetc(ic, input);
            strcpy(token.val, "|");
            token.id = OROP;
         }
         break;

      case '(':
      case ')':
         token.val[0] = (char) ic;
         token.val[1] = 0;
         token.id = HAAKJE;
         break;

      case '[':
      case ']':
         token.val[0] = (char) ic;
         token.val[1] = 0;
         token.id = BLOKHAAK;
         break;

      case '\'':
         strcpy(token.val, "'");
         token.id = QUOTE;
         break;

      case '?':
         strcpy(token.val, "?");
         token.id = QUESTIONMARK;
         break;

      case '\\':
         strcpy(token.val, "\\");
         token.id = BACKSLASH;
         break;

      case '{':
      case '}':
         token.val[0] = (char) ic;
         token.val[1] = 0;
         token.id = ACCOLADE;
         break;

      case '&':
         if((ic=fgetc(input)) == '&') {
            strcpy(token.val, "&&");
            token.id = COMPAND;
         }
         else {
            ungetc(ic, input);
            strcpy(token.val, "&");
            token.id = ANDOP;
         }
         break;

      case ':':
         strcpy(token.val, ":");
         token.id = DUBBELEPUNT;
         break;

      case '+':
         strcpy(token.val, "+");
         token.id = ADDITION;
         break;

      case '-':
         strcpy(token.val, "-");
         token.id = SUBSTRACTION;
         break;

      case ';':
         strcpy(token.val, ";");
         token.id = PUNTKOMMA;
         break;

      case ',':
         strcpy(token.val, ",");
         token.id = KOMMA;
         break;

      case '!':
         strcpy(token.val, "!");
         token.id = NEGATION;
         break;

      case '*':
         strcpy(token.val, "*");
         token.id = OPERATOR;
         break;

      case '.':
         strcpy(token.val, ".");
         token.id = DOT;
         break;

      case '#':
         strcpy(token.val, "#");
         token.id = HECK;
         break;

      case '>':
      case '<':
         token.val[0] = (char) ic;
         token.val[1] = 0;
         token.id = COMPARISON;
         break;

      case '\n':
         lineno++;
         lexAnalyze();		/* Go and fetch next token right now */
         break;			/* And break after return of recursion */

      default:
         token.id = 0;          /* XXX */
         strcpy(token.val, "???");
         
   }
}

void ptokid(void)
{
   if(inKeywordRange(token.id)) {
      pkeyword();
      return;
   }

   switch(token.id) {
      case IDID:          printf("identifier");
                          break;
      case COMMENT:       printf("comment");
                          break;
      case ARRAYID:       printf("array");
                          break;
      case EQUALSID:      printf("equals");
                          break;
      case COMPEQUALSIGN: printf("is equal?");
                          break;
      case STRINGID:      printf("string");
                          break;
      case OPERATOR:      printf("operator");
                          break;
      case HECK:          printf("heck");
                          break;
      case COMPARISON:    printf("comparison");
                          break;
      case DOT:           printf("dot");
                          break;
      case NUMBER:        printf("whole number");
                          break;
      case HAAKJE:        printf("haakje");
                          break;
      case ACCOLADE:      printf("accolade");
                          break;
      case PUNTKOMMA:     printf("punt-komma");
                          break;
      case KOMMA:         printf("komma");
                          break;
      case NEGATION:      printf("negation");
                          break;
      case ADDITION:      printf("addition");
                          break;
      case SUBSTRACTION:  printf("substraction");
                          break;
      case BLOKHAAK:      printf("blokhaak");
                          break;
      case QUOTE:         printf("quote");
                          break;
      case DUBBELEPUNT:   printf("dubbele punt");
                          break;
      case COMPOR:        printf("comparitive OR");
                          break;
      case OROP:          printf("OR operator");
                          break;
      case BACKSLASH:     printf("backslash");
                          break;
      case QUESTIONMARK:  printf("question mark");
                          break;
      case COMPAND:       printf("Comparitive AND");
                          break;
      case ANDOP:         printf("AND operator or Address of operator");
                          break;
      default:            printf("UNKNOWN");
                          break;
   }
}

void ptokval(void)
{
   printf("%s", token.val);
}

void ptoken(void)
{
   printf("Token: %s\t\t - Type: ", token.val);
   ptokid();
   printf("\n");
}

int isident(int c)
{
   return ((isalnum(c) || c == '_') ? 1 : 0);
}
